import java.util.concurrent.*;

public class CyclicBarrier {

    private Semaphore barrier = new Semaphore(0);
    private Semaphore mutex   = new Semaphore(1);
    private int parties;
    private int arrived = 0;

    public CyclicBarrier(int parties) {
	this.parties = parties;
    }

    public void await() throws InterruptedException {
	mutex.acquire();
	arrived++;
	if (arrived < parties) {
	    Semaphore myBarrier = barrier;
	    mutex.release();
	    myBarrier.acquire();
	}
	else {
	    for(int i = 1; i<parties; i++)
	        barrier.release();
	    arrived = 0;
	    barrier = new Semaphore(0);
	    mutex.release();
	}
    }
}
